<?
//This can be used via apisb.smartpayables.com or api.smartpayables.com (sandbox test environment, or live service)

// Here we define our client ID
define('AUTH_CLIENT_ID', '');

// And finally our auth key
define('AUTH_KEY', '');

// This function is an example of how to add a bank account via API
function add_bank_account() {
	$errors = array();
	
	$signature_filename = dirname(__FILE__) . '/signature_sample.bmp';
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'name_on_checks' => 'Test Name', 
		'address_on_checks' => 'Test Addr|Line 2|Line 3|Line 4', 
		'address' => 'Test Addr', 
		'address2' => 'Line 2',
		'city' => 'City', 
		'state' => 'State', 
		'zip' => '12345', 
		'account_number' => '123456789123' . rand(1, 100), 
		'routing_number' => '987654321' . rand(1, 100), 
		'bank_name' => 'My Bank', 
		'bank_address' => 'My Banks|Addr|Lines', 
		'bank_fractional_code' => '123/456-78', 
		'sig2_threshold' => 0, 
		'only_use_sig2_threshold' => 0, 
		'account_alias' => 'My API Test Account' . rand(1, 100), 
		'email_address' => '', 
		'alert_email_address' => 0, 
		'return_address' => '', 
		'starting_check_number' => '10',
		'currency' => 'USD', 
		'sig_file' => '@' . $signature_filename, 
	);

	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/payments/upload');

	// For live
  $ch = curl_init('http://api.smartpayables.com/bank-accounts/add');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  $xml = simplexml_load_string($s);
	
	foreach(libxml_get_errors() as $error) {
  	$errors[] = $error->message;
  }
    
  if ($xml{'status'} == 1) {
  	$bank_account_id = $xml->bankaccount->attributes()->id;
  
    if ($bank_account_id != "") {
    	$data = array(
    		'client_id' => AUTH_CLIENT_ID, 
    		'akey' => AUTH_KEY,
    		'item' => 'single-' . $bank_account_id
    	);

      $ch = curl_init('http://api.smartpayables.com/bank-accounts/confirm');
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $s = curl_exec($ch);
			
			return $s;
		} else {
			$errors[] = 'No Bank Account ID, Errors: ' . $s;
		}
	} else {
  	$errors[] = 'Errors returned: ' . $s;
  }
 	
 	return $errors;
}

// This function is an example of how to add a bank account via API
function assign_signature_to_bank_account($bank_account_id) {
	$errors = array();
	
	$signature_filename = dirname(__FILE__) . '/signature_sample.bmp';
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'bank_account_id' => $bank_account_id, 
		'sig_file' => '@' . $signature_filename 
	);

	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/payments/upload');

	// For live
  $ch = curl_init('http://api.smartpayables.com/bank-accounts/assign-signature');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  $xml = simplexml_load_string($s);
	
	foreach(libxml_get_errors() as $error) {
  	$errors[] = $error->message;
  }
    
  if ($xml{'status'} == 1) {
  	return $s;
	} else {
		$errors[] = 'Errors: ' . $s;
	}
 	
 	return $errors;
}

// This function is an example of how to upload a bank account file via API
function upload_bank_accounts_file() {
	$errors = array();
	
	// First we're going to generate it because we need unique values each time we test to avoid duplicate errors
	$file_path = dirname(__FILE__) . '/bank-account-test-file.csv';
	$f = fopen($file_path, 'w');
	fwrite($f, 'Bank Account Alias,Alert Email Address,Name On Checks,Address On Checks,Account Address,' . 
		'Account Address2,Account City,Account State,Account Zip,Account Number,Routing Number,Bank Name,' . 
		'Bank Address,Banks Fractional Code,Custom Return Address,Starting Check Number,Currency' . "\r\n");
	
	for ($i = 0; $i < 20; $i++) {
		fwrite($f, 'My API File Test Account A ' . $i . ' ' . rand(1, 10000) . 
			',,Name ' . $i . ',Addr ' . $i . ',Addr1,Addr2,City,State,12345,1234567142' . rand(1, 10000) . 
			',4321' . rand(1, 10000) . ',Bank ' . $i . ',Bank Addr One,123-45/67,,,' . "\r\n");
	}
		
	fclose($f);
	
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'userfile' => '@' . $file_path 
	);

	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/payments/upload');

	// For live
  $ch = curl_init('http://api.smartpayables.com/bank-accounts/upload');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);

  $xml = simplexml_load_string($s);
	
	foreach(libxml_get_errors() as $error) {
  	$errors[] = $error->message;
  }
    
  if ($xml{'status'} == 1) {
  	$file_id = $xml['fileid'];
  	
    if ($file_id != "") {
    	$data = array(
    		'client_id' => AUTH_CLIENT_ID, 
    		'akey' => AUTH_KEY,
    		'item' => 'file-' . $file_id
    	);

      $ch = curl_init('http://api.smartpayables.com/bank-accounts/confirm');
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $s = curl_exec($ch);
      
		  $xml = simplexml_load_string($s);
			
			foreach(libxml_get_errors() as $error) {
		  	$errors[] = $error->message;
		  }
				  
		  if (empty($errors)) {
  			$bank_account_id = $xml->bankaccounts->bankaccount[0]->bankaccount_id;
		  	$assign_signature_result = assign_signature_to_bank_account($bank_account_id);
      
				return array(
					'data' => $s, 
					'assign_signature_result' => $assign_signature_result 
				);
			}
		} else {
			$errors[] = 'No File ID, Errors: ' . $s;
		}
	} else {
  	$errors[] = 'Errors returned: ' . $s;
  }
 	
 	return $errors;
}

// This function is an example of how to activate, or deactivate a bank account via API
function change_active_status($bank_account_id, $activate = true) {
	$errors = array();
	
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'bank_account_id' => $bank_account_id
	);
	
	$method = ($activate ? 'activate' : 'deactivate');
	
	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/payments/' . $method);

	// For live
  $ch = curl_init('http://api.smartpayables.com/bank-accounts/' . $method);
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  $xml = simplexml_load_string($s);
	
	foreach(libxml_get_errors() as $error) {
  	$errors[] = $error->message;
  }
    
  if ($xml{'status'} == 1) {
  	return $s;
	} else {
		$errors[] = 'Errors: ' . $s;
	}
 	
 	return $errors;
}

// This function is an example of how to attempt to verify micro deposits
function verify_micro_deposits($bank_account_id, $one, $two) {
	$errors = array();
	
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'bank_account_id' => $bank_account_id,
		'amount_one' => $one, 
		'amount_two' => $two 
	);
	
	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/payments/verify-micro-deposits');

	// For live
  $ch = curl_init('http://api.smartpayables.com/bank-accounts/verify-micro-deposits');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  $xml = simplexml_load_string($s);
	
	foreach(libxml_get_errors() as $error) {
  	$errors[] = $error->message;
  }
    
  if ($xml{'status'} == 1) {
  	return $s;
	} else {
		$errors[] = 'Errors: ' . $s;
	}
 	
 	return $errors;
}

// This function is an example of how to attempt to retrieve a list of accounts, and potentially filter by 
// those requiring action eg. needing a signature, returned
function get_list($action_required) {
	$errors = array();
		
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'action_required' => ($action_required ? 1 : 0) 
	);
	
	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/payments/get-list');

	// For live
  $ch = curl_init('http://api.smartpayables.com/bank-accounts/get-list');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  $xml = simplexml_load_string($s);
	
	foreach(libxml_get_errors() as $error) {
  	$errors[] = $error->message;
  }
    
  if ($xml{'status'} == 1) {
  	return $s;
	} else {
		$errors[] = 'Errors: ' . $s;
	}
 	
 	return $errors;
}

// Let's call add bank account, it's preloaded with all the sample data
// $result = add_bank_account();

// Let's call upload bank accounts, it's preloaded with all the sample data
// this function also calls assign signature on one of the accounts to test / demonstrate that function too
// $result = upload_bank_accounts_file();

// Let's call change active state to demonstrate how to modify whether a bank account is active or not
// Deactivate
// $result = change_active_status(your bank account ID here, false);

// Activate
// $result = change_active_status(your bank account ID here, true);

// Verify micro deposits'
// $result = verify_micro_deposits(your bank account ID here, 'amount 1', 'amount 2');

// Get list - param is 'action required' eg. needs signature, returned, etc 
$result = get_list(false);

// Let's output this XML to show it
if (isset($result)) {
	echo '<pre>' . print_r($result, true) . '</pre>';
} else {
	echo 'no result';
}
?>