<?
//This can be used via apisb.smartpayables.com or api.smartpayables.com (sandbox test environment, or live service)

// Here we define our client ID
define('AUTH_CLIENT_ID', '1');

// And finally our auth key
define('AUTH_KEY', '');

// This function is an example of how to retrieve a list of check proofs that need reviewing
function get_review_list() {
	$errors = array();

	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY
	);

	// For sandbox
  $ch = curl_init('https://apisb.smartpayables.com/bank-accounts/check-proofs/get-review-list');

	// For live
  //$ch = curl_init('https://api.smartpayables.com/bank-accounts/check-proofs/get-review-list');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  return $s;
}

// This function is an example of how to retrieve a specific check proof image
function get_proof_image($id) {
	$errors = array();

	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY,
		'check_proof_id' => $id 
	);

	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/bank-accounts/check-proofs/get-proof-image');

	// For live
  $ch = curl_init('https://api.smartpayables.com/bank-accounts/check-proofs/get-proof-image');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  return $s;
}

// This function is an example of how to approve a specific check proof
function approve_check_proof($id) {
	$errors = array();

	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY,
		'check_proof_id' => $id 
	);

	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/bank-accounts/check-proofs/approve');

	// For live
  $ch = curl_init('https://api.smartpayables.com/bank-accounts/check-proofs/approve');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  return $s;
}

// This function is an example of how to reject a specific check proof
function reject_check_proof($id, $rejection_reason) {
	$errors = array();

	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY,
		'check_proof_id' => $id,
		'rejection_reason' => $rejection_reason 
	);

	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/bank-accounts/check-proofs/reject');

	// For live
  $ch = curl_init('https://api.smartpayables.com/bank-accounts/check-proofs/reject');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  return $s;
}

// This function is an example of how to retrieve check proof information by bank account ID
function get_check_proof_by_bank_account_id($bank_account_id) {
	$errors = array();

	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY,
		'bank_account_id' => $bank_account_id
	);

	// For sandbox
	//$ch = curl_init('https://apisb.smartpayables.com/bank-accounts/check-proofs/get-by-bank-account-id');

	// For live
  $ch = curl_init('https://api.smartpayables.com/bank-accounts/check-proofs/get-by-bank-account-id');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);
  
  return $s;
}

// Call to get a list of check proofs requiring review		
$result = get_review_list();

// Call to get a specific check proof image in JPG format where ID is valid (1 = ID)
//header('Content-Type: image/jpeg');
//$result = get_proof_image(1);

// Call to approve a check proof where ID is valid (1 = ID)
//$result = approve_check_proof(1);

// Call to reject a check proof where ID is valid (1 = ID) and reason is accurate ('test' = reason)
//$result = reject_check_proof(1, 'test');

// Call to get check proof information by bank account ID (1 = ID)
//$result = get_check_proof_by_bank_account_id(1);

// Show result
echo $result;
?>