<?
//This can be used via apisb.smartpayables.com or api.smartpayables.com (sandbox test environment, or live service)

// Here we define our client ID
define('AUTH_CLIENT_ID', '');

// And finally our auth key
define('AUTH_KEY', '');

// This function is an example of how to send a file to the API upload method, then confirm it if there is a file ID (no errors)
function upload_payment_file($filename) {
	$errors = array();
	
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'method_id' => 2, 
		'userfile' => '@' . $filename
	);

	// For sandbox
  //$ch = curl_init('https://apisb.smartpayables.com/payments/upload');

	// For live
  $ch = curl_init('https://api.smartpayables.com/payments/upload');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);

  $xml = simplexml_load_string($s);
	
	foreach(libxml_get_errors() as $error) {
  	$errors[] = $error->message;
  }
  
  if ($xml{'status'} == 1) {
  	$file_id = $xml->payments->payment->file_id;
    $file_id = $xml{'fileid'};

    if ($file_id != "") {
    	$data = array(
    		'client_id' => AUTH_CLIENT_ID, 
    		'akey' => AUTH_KEY,
    		'item' => 'file-' . $file_id
    	);

      $ch = curl_init('https://api.smartpayables.com/payments/confirm');
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $s = curl_exec($ch);
			
			return $s;
		} else {
			$errors[] = 'No file ID, payment file errors: ' . $s;
		}
	} else {
  	$errors[] = 'Errors returned: ' . $s;
  }
 	
 	return $errors;
}

// Let's call the payment file upload. Don't forget, this example will require your format to match the mapping on the 
// system, so you may need to set this up with support first
$payment_file_path = dirname(__FILE__) . '/test-file.csv';
$result = upload_payment_file($payment_file_path);

// Let's output this XML to show it
echo '<pre>' . print_r($result, true) . '</pre>';
?>